#pragma once
#include "Macrodef.h"
#include "TimDescriptor.h"
#define MAX_RESERVED_SIZE   4
#define MAX_FBF_SIZE   0x10000000 
#define MAX_UPLOAD_SIZE 0x10000000 



typedef struct _EraseOnlyArea
{
	tstring m_sEraseStartAddress;
	tstring m_sEraseLenth;
	UINT32  m_uiPartition;

	_EraseOnlyArea():m_sEraseStartAddress(_T("")), m_sEraseLenth(_T("")),m_uiPartition(0){}
	void operator = (struct _EraseOnlyArea& EraseOnly_Area)
	{
		m_sEraseStartAddress = EraseOnly_Area.m_sEraseStartAddress;
		m_sEraseLenth = EraseOnly_Area.m_sEraseLenth;
		m_uiPartition = EraseOnly_Area.m_uiPartition;
	}
	~ _EraseOnlyArea() {};


}EraseOnlyArea,*pEraseOnlyArea;

typedef list<EraseOnlyArea*>           t_EraseOnlyAreaList;
typedef list<EraseOnlyArea*>::iterator t_EraseOnlyAreaIter;

typedef enum 
{
	ERASE_ALL_NOTSET = 0,
	ERASE_ALL_BEFOREBURNING = 1,
	ERASE_ALL_WIHTOUTBURNING = 2,
	UNKNOWN_MODE = 0xFF

}eEraseAllMode;

typedef struct _BlfInfoProperty
{
	t_EraseOnlyAreaList    m_EraseOnlyAreaList;
	eEraseAllMode          m_eEraseAllFlash;
	bool 	               m_bResetBBT,
						   m_bTrusted,
	                       m_bProductionMode;
	tstring			       m_sFlashFamily,
    			           m_sSkipBlockNumbers,
						   m_sBlfVersion,
						   m_sFlashDataPageSize,
	                       m_sFlashSpareAreaSize,
						   m_sFlasherLoadaddress,
						   m_sReserved1,
	                       m_sReserved2,
                           m_sReserved3;
	unsigned int           m_FBFSectorSize,
		                   m_MaxFBFSize,
						   m_MaxUploadSize,
						   m_FlashBlockSize,
						   m_Command,
	                       m_Reserved[MAX_RESERVED_SIZE];
	unsigned short int     m_NandFlashID;
	unsigned short int     m_Platform; // 0--MMP2;1--WKNG;2--NEVO
	CTimDescriptor*        m_pTimDescriptor;

	void operator = (struct _BlfInfoProperty& rhs)
	{
		
		m_eEraseAllFlash = rhs.m_eEraseAllFlash;
		m_bResetBBT = rhs.m_bResetBBT;
		m_bTrusted = rhs.m_bTrusted;
		m_bProductionMode = rhs.m_bProductionMode;
		m_pTimDescriptor = rhs.m_pTimDescriptor;
		m_sSkipBlockNumbers = rhs.m_sSkipBlockNumbers;
		m_sBlfVersion = rhs.m_sBlfVersion;
		m_sFlashFamily = rhs.m_sFlashFamily;
		m_FBFSectorSize = rhs.m_FBFSectorSize;
		m_NandFlashID = rhs.m_NandFlashID;
		m_sFlashDataPageSize = rhs.m_sFlashDataPageSize;
		m_sFlashSpareAreaSize = rhs.m_sFlashSpareAreaSize;
		m_MaxFBFSize = rhs.m_MaxFBFSize;
		m_MaxUploadSize = rhs.m_MaxUploadSize;
		m_FlashBlockSize = rhs.m_FlashBlockSize;
		m_Command = rhs.m_Command;
		m_sFlasherLoadaddress = rhs.m_sFlasherLoadaddress;
		m_Platform = rhs.m_Platform;
		m_sReserved1 =  rhs.m_sReserved1;
		m_sReserved2 =  rhs.m_sReserved2;
		m_sReserved3 =  rhs.m_sReserved3;
        memcpy(&m_Reserved,&rhs.m_Reserved,sizeof(m_Reserved));
		t_EraseOnlyAreaIter EraseonlyIter = rhs.m_EraseOnlyAreaList.begin();
		while(EraseonlyIter!=rhs.m_EraseOnlyAreaList.end())
		{
			pEraseOnlyArea pEraseonlyarea = new EraseOnlyArea();
			*pEraseonlyarea = **EraseonlyIter;
			m_EraseOnlyAreaList.push_back(pEraseonlyarea);
			EraseonlyIter++;
		}
		
	}
	_BlfInfoProperty(): m_eEraseAllFlash(ERASE_ALL_NOTSET),m_bResetBBT(false),m_bTrusted(false),m_bProductionMode(false), 
                        m_sFlashFamily(_T("")),m_sSkipBlockNumbers(_T("")),
						m_sBlfVersion(_T("")),m_FBFSectorSize(0),m_MaxFBFSize(MAX_FBF_SIZE),m_FlashBlockSize(0),
						m_MaxUploadSize(MAX_UPLOAD_SIZE),m_NandFlashID(0),m_Command(0),m_sFlashDataPageSize(_T("")),
						m_sFlashSpareAreaSize(_T("")),m_sFlasherLoadaddress(_T("")),m_sReserved1(_T("")),
                        m_sReserved2(_T("")),m_sReserved3(_T(""))
	{ 
		memset(&m_Reserved,0,sizeof(m_Reserved));
		m_pTimDescriptor = new CTimDescriptor();
		m_EraseOnlyAreaList.clear();
	}
	~_BlfInfoProperty()
	{
	  delete m_pTimDescriptor;
 	  t_EraseOnlyAreaIter EraseonlyIter = m_EraseOnlyAreaList.begin();
	  while(EraseonlyIter!=m_EraseOnlyAreaList.end())
	  {
		  delete *EraseonlyIter++;
	  }

	  m_pTimDescriptor = NULL;
	}

}BlfInfoProperty;

