 /*  publication of such source code.
 *  This Module contains Proprietary Information of Marvell and should be
 *  treated as Confidential.
 *  The information in this file is provided for the exclusive use of the 
 *  licensees of Marvell.
 *  Such users have the right to use, modify, and incorporate this code into 
 *  products for purposes authorized by the license agreement provided they 
 *  include this notice and the associated copyright notice with any such
 *  product. 
 *  The information in this file is provided "AS IS" without warranty.
 *
 ******************************************************************************/
#pragma once
#include "Macrodef.h"

#include "ErdBase.h"

class  CConsumerID : public CErdBase
{
public:
	CConsumerID();
	virtual ~CConsumerID(void);

	// copy constructor
	CConsumerID( const CConsumerID& rhs );
	// assignment operator
	virtual CConsumerID& operator=( const CConsumerID& rhs );

	void Reset();

	static const tstring Begin;	// "Consumer ID"
	static const tstring End;	// "End Consumer ID"

 	virtual bool ReadBLF(tifstream& ifsBlf,tstring sErdline);
	virtual const tstring& PackageName(){ return Begin; }
	virtual const tstring& PackageEndName(){ return End; }
	virtual unsigned int PackageSize();
	virtual int AddPkgStrings( CReservedPackageData* pRPD );

    virtual bool WriteBLF( tofstream& ofs);
	
	void psCID( tstring& sCID ) ;
	tstring* psCID() ;
	enum eConsumerID { CID, PID, CONSUMERID_MAX };

	t_stringVector	m_PIDs;
};

typedef vector<CConsumerID*>           t_ConsumerIDVec;
typedef vector<CConsumerID*>::iterator t_ConsumerIDVecIter;

